from  .baseApi import BaseAPI
from .urls import URL
class HqCrawl(BaseAPI):
    def __init__(self):
        super(HqCrawl, self).__init__()

    def get_room_info(self,xh):
        json = self.request(URL.get_hq_room_info_url(xh))
        try:
            data = self.get_json(json)
        except Exception as e:
            return {}
        if data.get("house") is None:
            return {}
        result = dict(name=data.get("house").get('xm'), roomid=data.get("house").get('roomid'),
                      areaName=data.get("house").get('areaName'), lymc=data.get("house").get('lymc'),
                      fjmc=data.get("house").get('fjmc'), sy=data.get("sy"))
        return result

    def get_df_info(self,xh,params = None):
        flag = False
        if params is None:
            flag = True
            params = self.get_room_info(xh)
            if params == {}:
                return {}
        json = self.request(URL.get_hq_df_url(**params))
        try:
            data = self.get_json(json)
        except Exception as e:
            return {}
        if params.get("areaName") == "鱼山校区":
            temp = dict(restAmp=data['data'].get("Sydl"))
            data['data'] = temp
        if flag is True:
            data["info"] = params
        return data
